org.apache.poi.hwpf.model

## Class CHPFormattedDiskPage

- java.lang.Object
- - org.apache.poi.hwpf.model.FormattedDiskPage
  - - org.apache.poi.hwpf.model.CHPFormattedDiskPage

-     @Internal
      public final class CHPFormattedDiskPage
      extends FormattedDiskPage

  Represents a CHP fkp. The style properties for paragraph and character runs are stored in fkps. There are PAP fkps for paragraph properties and CHP fkps for character run properties. The first part of the fkp for both CHP and PAP fkps consists of an array of 4 byte int offsets that represent a Paragraph's or Character run's text offset in the main stream. The ending offset is the next value in the array. For example, if an fkp has X number of Paragraph's stored in it then there are (x + 1) 4 byte ints in the beginning array. The number X is determined by the last byte in a 512 byte fkp. CHP and PAP fkps also store the compressed styles(grpprl) that correspond to the offsets on the front of the fkp. The offset of the grpprls is determined differently for CHP fkps and PAP fkps.
  Author:
    Ryan Ackley

- - ### Field Summary

    - ### Fields inherited from class org.apache.poi.hwpf.model.FormattedDiskPage

      `_crun, _fkp, _offset`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CHPFormattedDiskPage()`
    `CHPFormattedDiskPage(byte[] documentStream, int offset, CharIndexTranslator translator)` This constructs a CHPFormattedDiskPage from a raw fkp (512 byte array read from a Word file).
    `CHPFormattedDiskPage(byte[] documentStream, int offset, int fcMin, TextPieceTable tpt)` Deprecated. Use `CHPFormattedDiskPage(byte[], int, CharIndexTranslator)` instead

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `fill(java.util.List<CHPX> filler)`
    `CHPX` | `getCHPX(int index)`
    `java.util.List<CHPX>` | `getCHPXs()`
    `protected byte[]` | `getGrpprl(int index)` Gets the chpx for the character run at index in this fkp.
    `java.util.ArrayList<CHPX>` | `getOverflow()`
    `protected byte[]` | `toByteArray(CharIndexTranslator translator)`

    - ### Methods inherited from class org.apache.poi.hwpf.model.FormattedDiskPage

      `getEnd, getStart, size`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CHPFormattedDiskPage

          public CHPFormattedDiskPage()

    - #### CHPFormattedDiskPage

          @Deprecated
          public CHPFormattedDiskPage(byte[] documentStream,
                                                  int offset,
                                                  int fcMin,
                                                  TextPieceTable tpt)

      Deprecated. Use `CHPFormattedDiskPage(byte[], int, CharIndexTranslator)` instead
      This constructs a CHPFormattedDiskPage from a raw fkp (512 byte array read from a Word file).

    - #### CHPFormattedDiskPage

          public CHPFormattedDiskPage(byte[] documentStream,
                                      int offset,
                                      CharIndexTranslator translator)

      This constructs a CHPFormattedDiskPage from a raw fkp (512 byte array read from a Word file).

  - ### Method Detail

    - #### getCHPX

          public CHPX getCHPX(int index)

    - #### getCHPXs

          public java.util.List<CHPX> getCHPXs()

    - #### fill

          public void fill(java.util.List<CHPX> filler)

    - #### getOverflow

          public java.util.ArrayList<CHPX> getOverflow()

    - #### getGrpprl

          protected byte[] getGrpprl(int index)

      Gets the chpx for the character run at index in this fkp.
      Specified by:
        `getGrpprl` in class `FormattedDiskPage`
      Parameters:
        `index` - The index of the chpx to get.
      Returns:
        a chpx grpprl.

    - #### toByteArray

          protected byte[] toByteArray(CharIndexTranslator translator)

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.